# Disable generation of debuginfo package
%global debug_package %{nil}
%global namedreltag .Final
%global namedversion %{version}%{?namedreltag}

Name:           netty
Version:        4.0.42
Release:        %mkrel 1
Group:          Development/Java
Summary:        An asynchronous event-driven network application framework and tools for Java
License:        ASL 2.0
URL:            https://netty.io/
Source0:        https://github.com/netty/netty/archive/netty-%{namedversion}.tar.gz
Patch0:         0001-Remove-OpenSSL-parts-depending-on-tcnative.patch
Patch1:         0002-Remove-NPN-ALPN.patch

BuildRequires:  maven-local
BuildRequires:  mvn(ant-contrib:ant-contrib)
BuildRequires:  mvn(com.google.protobuf:protobuf-java)
BuildRequires:  mvn(com.jcraft:jzlib)
BuildRequires:  mvn(commons-logging:commons-logging)
BuildRequires:  mvn(kr.motd.maven:os-maven-plugin)
BuildRequires:  mvn(log4j:log4j:1.2.17)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.logging.log4j:log4j-api)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires:  mvn(org.bouncycastle:bcpkix-jdk15on)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.fusesource.hawtjni:maven-hawtjni-plugin)
BuildRequires:  mvn(org.javassist:javassist)
BuildRequires:  mvn(org.jboss.marshalling:jboss-marshalling)
BuildRequires:  mvn(org.jctools:jctools-core)
BuildRequires:  mvn(org.slf4j:slf4j-api)
BuildRequires:  mvn(org.sonatype.oss:oss-parent:pom:)

Provides:       netty4 = %{version}-%{release}
Obsoletes:      netty4 < %{version}-%{release}

%description
Netty is a NIO client server framework which enables quick and easy
development of network applications such as protocol servers and
clients. It greatly simplifies and streamlines network programming
such as TCP and UDP socket server.

'Quick and easy' doesn't mean that a resulting application will suffer
from a maintainability or a performance issue. Netty has been designed
carefully with the experiences earned from the implementation of a lot
of protocols such as FTP, SMTP, HTTP, and various binary and
text-based legacy protocols. As a result, Netty has succeeded to find
a way to achieve ease of development, performance, stability, and
flexibility without a compromise.

%package javadoc
Summary:   API documentation for %{name}

%description javadoc
%{summary}.

%prep
%setup -q -n netty-netty-%{namedversion}

%patch0 -p1
%patch1 -p1

# Missing Mavenized rxtx
%pom_disable_module "transport-rxtx"
%pom_remove_dep ":netty-transport-rxtx" all
# Missing com.barchart.udt:barchart-udt-bundle:jar:2.3.0
%pom_disable_module "transport-udt"
%pom_remove_dep ":netty-transport-udt" all
%pom_remove_dep ":netty-build" all
# Not needed
%pom_disable_module "example"
%pom_remove_dep ":netty-example" all
%pom_disable_module "testsuite"
%pom_disable_module "testsuite-osgi"
%pom_disable_module "tarball"
%pom_disable_module "microbench"
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :animal-sniffer-maven-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :maven-antrun-plugin
%pom_remove_plugin :maven-dependency-plugin
%pom_remove_plugin :maven-shade-plugin
%pom_remove_plugin :maven-shade-plugin common
%pom_remove_plugin :xml-maven-plugin
%pom_remove_plugin -r :maven-release-plugin
%pom_remove_plugin -r :maven-clean-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin -r :maven-deploy-plugin
%pom_remove_plugin -r :maven-jxr-plugin
# Optional things we don't ship
%pom_remove_dep ":\${tcnative.artifactId}"
%pom_remove_dep ":\${tcnative.artifactId}" handler
%pom_remove_dep "org.eclipse.jetty.npn:npn-api"
%pom_remove_dep "org.eclipse.jetty.npn:npn-api" handler
%pom_remove_dep "org.eclipse.jetty.alpn:alpn-api"
%pom_remove_dep "org.eclipse.jetty.alpn:alpn-api" handler

sed -i 's|taskdef|taskdef classpathref="maven.plugin.classpath"|' all/pom.xml

%pom_xpath_inject "pom:plugins/pom:plugin[pom:artifactId = 'maven-antrun-plugin']" '<dependencies><dependency><groupId>ant-contrib</groupId><artifactId>ant-contrib</artifactId><version>1.0b3</version></dependency></dependencies>' all/pom.xml
%pom_xpath_inject "pom:execution[pom:id = 'build-native-lib']/pom:configuration" '<verbose>true</verbose>' transport-native-epoll/pom.xml

# Upstream has jctools bundled.
%pom_xpath_set "pom:build/pom:plugins/pom:plugin[pom:artifactId = 'maven-bundle-plugin']/pom:executions/pom:execution[pom:id = 'generate-manifest']/pom:configuration/pom:instructions/pom:Import-Package" 'org.jctools.*,sun.misc;resolution:=optional;*' common/pom.xml

# Tell xmvn to install attached artifact, which it does not
# do by default. In this case install all attached artifacts with
# the linux classifier.
%mvn_package ":::linux*:"

%build
export CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS"
%mvn_build -f

%install
%mvn_install

%files -f .mfiles
%doc LICENSE.txt NOTICE.txt

%files javadoc -f .mfiles-javadoc
%doc LICENSE.txt NOTICE.txt




%changelog
* Sat Dec 15 2018 daviddavid <daviddavid> 4.0.42-1.mga6
+ Revision: 1341480
- new version: 4.0.42, fixes CVE-2016-4970 (mga#23974)

* Wed Feb 24 2016 neoclust <neoclust> 4.0.28-3.mga6
+ Revision: 977740
- First rebuild of the java stack
- sync package netty with fedora
- Rebuild against current java stack
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Fri May 22 2015 luigiwalser <luigiwalser> 4.0.28-1.mga5
+ Revision: 822589
- 4.0.28 (fixes CVE-2015-2156, sync with f21)

* Fri Dec 26 2014 pterjan <pterjan> 4.0.19-2.mga5
+ Revision: 806312
- Clean rebuild
- Disable transport-native-epoll plugin for now
- Sync with Fedora 21 (update to 4.0.19)
+ umeabot <umeabot>
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild
- Mageia 4 Mass Rebuild
+ dmorgan <dmorgan>
- New version

* Sun Sep 15 2013 dmorgan <dmorgan> 3.6.3-3.mga4
+ Revision: 479894
- Set scope of optional compile dependencies to provided
- Drop dependency on OSGi
- Resolves: rhbz#916139

* Sun Sep 15 2013 dmorgan <dmorgan> 3.6.3-1.mga4
+ Revision: 479815
- Update to upstream version 3.6.3

* Fri Jul 12 2013 dmorgan <dmorgan> 3.6.2-1.mga4
+ Revision: 453276
- New version

* Thu Jul 11 2013 dmorgan <dmorgan> 3.6.1-1.mga4
+ Revision: 453193
- New version
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 dmorgan <dmorgan> 3.5.11-2.mga3
+ Revision: 339018
- New version

* Tue Dec 04 2012 dmorgan <dmorgan> 3.5.9-1.mga3
+ Revision: 326378
- New version

* Mon Dec 03 2012 dmorgan <dmorgan> 3.5.8-1.mga3
+ Revision: 325730
- New version

* Wed Sep 12 2012 dmorgan <dmorgan> 3.5.7-1.mga3
+ Revision: 292785
- New version

* Sun Sep 09 2012 dmorgan <dmorgan> 3.2.4-2.mga3
+ Revision: 291469
- Add enforcer-plugin to BR

* Mon Jun 25 2012 dmorgan <dmorgan> 3.2.4-1.mga3
+ Revision: 263738
- New version 3.2.4

* Sat Jul 23 2011 dmorgan <dmorgan> 3.2.3-5.mga2
+ Revision: 128111
- Add buildrequire
- Fix FTBFS.
    - Adapt to current guidelines.

* Wed Apr 27 2011 dmorgan <dmorgan> 3.2.3-4.mga1
+ Revision: 91987
- Rebuild after bootstrapping
- imported package netty


* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 17 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 3.2.3-2
- Use maven 3 to build
- Drop ant-contrib depmap (no longer needed)

* Thu Jan 13 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 3.2.3-1
- Initial version of the package

